unit T_MINE;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

const
  MAXColumns=20;
  MAXRows=20;

type
  TButtonStatus=(isFree,isBomb,isQuestion,isDeactived,isDead);
  TMineGrid   = Array[0..MAXColumns-1,0..MAXRows-1] of TBUTTONSTATUS;
  TWinGameEvent = procedure(Sender: TObject) of Object;
  TMine = class(TGraphicControl)
  private
   N:INTEGER;
   COLUMNS,ROWS:INTEGER;
   fBitmap:TBitmap;

   fPlaying:Boolean;
   VET:TMinegrid;
   fOnWinGame:TWinGameEvent;
   fOnfalseMove:TNotifyEvent;
   FBACK,FBUTC:TCOLOR;
   PROCEDURE PUT_BOMBS;
   PROCEDURE FSETBACK(C:TCOLOR);
   PROCEDURE FSETBUTC(C:TCOLOR);
   procedure DrawBlock(X,Y: Integer);
//   procedure fSetBitmap(Value: TBitmap);
   PROCEDURE SET_ROWS(V:INTEGER);
   PROCEDURE SET_COLUMNS(V:INTEGER);
  protected
    { Protected declarations }
  public
   procedure Paint; override;
   procedure Click; override;
   procedure newGame;
   constructor Create(AOwner:TComponent); override;
   destructor Destroy; override;
    { Public declarations }
  published
   property BackColor:TColor read fBack write fSetBack;
   property ButtonColor:TColor read fBUTC write fSetBUTC;
//   property BackBitmap: TBitmap read fBitmap write fSetBitmap;
   PROPERTY Bombs:INTEGER READ N WRITE N;
   property OnWinGame: TWinGameEvent read fOnWinGame write fOnWinGame;
   PROPERTY NumberOfRows:INTEGER READ ROWS WRITE SET_ROWS;
   PROPERTY NumberOfColumns:INTEGER READ COLUMNS WRITE SET_COLUMNS;

  end;

procedure Register;

implementation

{$R R_MINE.RES}

PROCEDURE TMINE.SET_ROWS(V:INTEGER);
 BEGIN
  IF V IN [0..MAXROWS] THEN
   IF V<>ROWS THEN
    BEGIN
     ROWS:=V;
     PAINT;
    END;
 END;

PROCEDURE TMINE.SET_COLUMNS(V:INTEGER);
 BEGIN
  IF V IN [0..MAXCOLUMNS] THEN
   IF V<>COLUMNS THEN
    BEGIN
     COLUMNS:=V;
     PAINT;
    END;
 END;
{
procedure TMine.fSetBitmap(Value: TBitmap);
Begin
    FBitmap.Assign(Value);
    Paint;
End;
}
procedure TMine.fSetBack(C:TColor);
begin
 fback:=C;
 Paint;
end;

procedure TMine.fSetBUTC(C:TColor);
begin
 fBUTC:=C;
 Paint;
end;

procedure TMine.DrawBlock(X,Y:Integer);
 Var
  Dx,Dy:real;
  X1,Y1,X2,Y2: Integer;
  S:STRING;

 PROCEDURE SHOW_BUT;
  BEGIN
   WITH CANVAS DO
    BEGIN
     Pen.Color:=FBUTC;
     Brush.Color:=FBUTC;
     rectangle(X1,Y1,X2,Y2);
     Pen.Color:=clBtnHighLight;
     MoveTo(X1,Y2);LineTo(X1,Y1);LineTo(X2,Y1);
     pen.Color:=clBtnShadow;
     LineTo(X2,Y2);LineTo(X1+1,Y2);
    END;
  END;

 Begin
  Dx:=Width / Columns;
  Dy:=Height / Rows;
  X1:=Round(X*Dx)+1;
  Y1:=Round(Y*Dy)+1;
  X2:=Round((X+1)*Dx)-1;
  Y2:=Round((Y+1)*Dy)-1;
  IF VET[X,Y]<>isDeactived THEN
   SHOW_BUT
  ELSE
   BEGIN
    CANVAS.Pen.Color:=FBACK;
    CANVAS.Brush.Color:=FBACK;
    CANVAS.rectangle(X1-1,Y1-1,X2,Y2);
   END;
  //SHOW GRYPS
  S:='';
  IF VET[X,Y]=isBomb THEN
   S:='EXPLO';
  IF S<>'' THEN
   BEGIN
    FBitmap.Handle:=LoadBitmap(hInstance,PCHAR(S));
    canvas.draw(x1,y1,fbitmap);
   END;
 End;

//Constructor
constructor TMine.Create(AOwner:TComponent);
 Begin
  Inherited create(AOwner);
  fBitmap:=TBitmap.Create;
  fPlaying:=False;
  COLUMNS:=5;
  ROWS:=5;
  FBUTC:=CLBTNFACE;
 End;

destructor TMine.Destroy;
 begin
  inherited destroy;
  fBitmap.Destroy;
 end;

PROCEDURE TMINE.PUT_BOMBS;
 VAR
  X,Y,C:INTEGER;
 BEGIN
  //INITIALIZE
  RANDOMIZE;
  FOR X:=0 TO COLUMNS-1 DO
   FOR Y:=0 TO ROWS-1 DO
    VET[X,Y]:=isFree;
  //ADD BOMBS
  FOR C:=1 TO N DO
   BEGIN
    REPEAT
     X:=RANDOM(COLUMNS);
     Y:=RANDOM(ROWS);
    UNTIL VET[X,Y]=isFree;
    VET[X,Y]:=isBomb;//HERE THER'S A BOMB
   END;
 END;

procedure TMine.newGame;
Begin
 If (fPlaying=false) or (MessageDlg('Stop game in progess?',mtConfirmation,[mbYes,mbNo],0)=mrYes) then
  begin
   PUT_BOMBS;
   Paint;
   fPlaying:=true;
  end;
End;

procedure TMine.Click;
 Var
  TX,Ty: Integer;
  P: TPoint;
 begin
  inherited click;
  if fPlaying then
   begin
    GetCursorPos(P);
    P:=ScreenToClient(P);
    Tx:=(P.X div Round(Width/Columns));
    TY:=(P.Y div Round(HEIGHT/ROWS));
    VET[TX,TY]:=isDEACTIVED;
    DRAWBLOCK(TX,TY);//PAINT;
   END;
  If Assigned(OnClick) then
   Onclick(self);
 End;

procedure TMine.Paint;
 Var
  X,Y:Integer;
 Begin
  INHERITED PAINT;
//  If fBitmap<>nil then
//   Canvas.StretchDraw(ClientRect,fbitmap);
  For X:=0 to Columns-1 do
   For Y:=0 to Rows-1 do
    DrawBlock(X,Y);
 End;

procedure Register;
 begin
  RegisterComponents('Bianco', [TMine]);
 end;

END.
